export class FiveRecord {
    constructor(key, versionKey, data, dateStart) {
        this.key = key;
        this.versionKey = versionKey;
        this.data = data;
        this.dateStart = dateStart ? dateStart : '';
        ;
    }
    dup() {
        const data = JSON.parse(JSON.stringify(this.data));
        const record = new FiveRecord(this.key, this.versionKey, data);
        return record;
    }
    isNewRecord() {
        if (this.data === null) {
            return true;
        }
        return false;
    }
    // we specify any as it now returns a special Keys Object, we need to make this part of the external api
    getKey() {
        return this.key;
    }
    getVersionKey() {
        return this.versionKey;
    }
    setKey(key) {
        this.key = key;
    }
    setVersionKey(versionKey) {
        this.versionKey = versionKey;
    }
    setData(data) {
        this.data = data;
    }
    getValue(fieldName) {
        const partialMatch = fieldName.indexOf('.') === -1;
        if (!partialMatch) {
            return this.data[fieldName];
        }
        const keys = Object.keys(this.data);
        for (let i = 0; i < keys.length; i++) {
            const key = keys[i];
            if (key.indexOf(fieldName) != -1) {
                return this.data[key];
            }
        }
        return null;
    }
    getFieldNameValues() {
        const fields = new Array();
        const values = new Array();
        const keys = Object.keys(this.data);
        keys.forEach((key) => {
            fields.push(key);
            values.push(this.data[key]);
        });
        const fieldsAndValues = {
            fields: fields,
            values: values,
        };
        return fieldsAndValues;
    }
}
export class QuestionDialogParameters {
    constructor(question) {
        this.question = question;
        this.onPositiveText = 'Yes';
        this.onNegativeText = 'No';
        this.onPositiveAction = null;
        this.onNegativeAction = null;
    }
}
