import { IFive, IFivePage, IFormField } from "./Five";
import { FiveRecord } from "./FiveRecord";

export interface CustomFieldProps {
    ref: any; //React.RefObject<CustomEditorRef>;

    value: any;
    fivePage: IFivePage;
    formField: IFormField;
    selectedRecord: FiveRecord;

    five: IFive;
    
    onValueUpdated: (value: any) => void;
    registerSaveCallback: (callback: (requestResult: any, type: any) => void) => void;
    registerChangeCallback: (callback: (updateFormField: IFormField) => void) => void;

    focusControl: boolean;
    variant: any;
    theme: any;

    conflictData: ConflictDataType;
}

export interface CustomEditorRef {
    onWillFullscreen: (fullscreen: boolean) => void;
    onFullscreen: (fullscreen: boolean) => void;
    onOk: (closeDialog: () => void) => void;
    onCancel: (closeDialog: () => void) => void;
}

export interface CustomFormProps {
    five: IFive;
    theme: any;
    componentStorage: any;
}

export type ConflictDataType = { 
    formField: IFormField;
    currentValue: any;
    serverValue: any;
    options: any;
}
